---
title: WebGLRenderingContext.compressedTexSubImage2D()
slug: Web/API/WebGLRenderingContext/compressedTexSubImage2D
tags:
  - API
  - Method
  - Reference
  - Textures
  - WebGL
  - WebGL extension
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.compressedTexSubImage2D()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API </a>specifies a two-dimensional sub-rectangle for a texture image in a compressed format.</p>

<p>Compressed image formats must be enabled by <a href="/en-US/docs/Web/API/WebGL_API/Using_Extensions">WebGL extensions</a> before using this method or a {{domxref("WebGL2RenderingContext")}} must be used.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">// WebGL 1:
void <var>gl</var>.compressedTexSubImage2D(<var>target</var>, <var>level</var>, <var>xoffset</var>, <var>yoffset</var>, <var>width</var>, <var>height</var>, <var>format</var>, ArrayBufferView? <var>pixels</var>);

// Additionally available in WebGL 2:
void gl.compressedTexSubImage2D(target, level, xoffset, yoffset, width, height, format, imageSize, offset);
void gl.compressedTexSubImage2D(target, level, xoffset, yoffset, width, height, format, ArrayBufferView srcData, optional srcOffset, optional srcLengthOverride);

</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>target</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the binding point (target) of the active compressed texture. Possible values:
 <ul>
  <li><code>gl.TEXTURE_2D</code>: A two-dimensional texture.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_POSITIVE_X</code>: Positive X face for a cube-mapped texture.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_NEGATIVE_X</code>: Negative X face for a cube-mapped texture.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_POSITIVE_Y</code>: Positive Y face for a cube-mapped texture.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_NEGATIVE_Y</code>: Negative Y face for a cube-mapped texture.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_POSITIVE_Z</code>: Positive Z face for a cube-mapped texture.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_NEGATIVE_Z</code>: Negative Z face for a cube-mapped texture.</li>
 </ul>
 </dd>
 <dt><code>level</code></dt>
 <dd>A {{domxref("GLint")}} specifying the level of detail. Level 0 is the base image level and level <em>n</em> is the <em>n</em>th mipmap reduction level.</dd>
 <dt><code>xoffset</code></dt>
 <dd>A {{domxref("GLint")}} specifying the horizontal offset within the compressed texture image.</dd>
 <dt><code>yoffset</code></dt>
 <dd>A {{domxref("GLint")}} specifying the vertical offset within the compressed texture image.</dd>
 <dt><code>width</code></dt>
 <dd>A {{domxref("GLsizei")}} specifying the width of the compressed texture.</dd>
 <dt><code>height</code></dt>
 <dd>A {{domxref("GLsizei")}} specifying the height of the compressed texture.</dd>
 <dt><code>format</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the compressed image format. Compressed image formats must be enabled by <a href="/en-US/docs/Web/API/WebGL_API/Using_Extensions">WebGL extensions</a> before using this method. Possible values:
 <ul>
  <li>When using the {{domxref("WEBGL_compressed_texture_s3tc")}} extension:
   <ul>
    <li><code>ext.COMPRESSED_RGB_S3TC_DXT1_EXT</code></li>
    <li><code>ext.COMPRESSED_RGBA_S3TC_DXT1_EXT</code></li>
    <li><code>ext.COMPRESSED_RGBA_S3TC_DXT3_EXT</code></li>
    <li><code>ext.COMPRESSED_RGBA_S3TC_DXT5_EXT</code></li>
   </ul>
  </li>
  <li>When using the {{domxref("WEBGL_compressed_texture_s3tc_srgb")}} extension:
   <ul>
    <li><code>ext.COMPRESSED_SRGB_S3TC_DXT1_EXT</code></li>
    <li><code>ext.COMPRESSED_SRGB_ALPHA_S3TC_DXT1_EXT</code></li>
    <li><code>ext.COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT</code></li>
    <li><code>ext.COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT</code></li>
   </ul>
  </li>
  <li>When using the {{domxref("WEBGL_compressed_texture_etc")}} extension:
   <ul>
    <li><code>ext.COMPRESSED_R11_EAC</code></li>
    <li><code>ext.COMPRESSED_SIGNED_R11_EAC</code></li>
    <li><code>ext.COMPRESSED_RG11_EAC</code></li>
    <li><code>ext.COMPRESSED_SIGNED_RG11_EAC</code></li>
    <li><code>ext.COMPRESSED_RGB8_ETC2</code></li>
    <li><code>ext.COMPRESSED_RGBA8_ETC2_EAC</code></li>
    <li><code>ext.COMPRESSED_SRGB8_ETC2</code></li>
    <li><code>ext.COMPRESSED_SRGB8_ALPHA8_ETC2_EAC</code></li>
    <li><code>ext.COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2</code></li>
    <li><code>ext.COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2</code></li>
   </ul>
  </li>
  <li>When using the {{domxref("WEBGL_compressed_texture_pvrtc")}} extension:
   <ul>
    <li><code>ext.COMPRESSED_RGB_PVRTC_4BPPV1_IMG</code></li>
    <li><code>ext.COMPRESSED_RGBA_PVRTC_4BPPV1_IMG</code></li>
    <li><code>ext.COMPRESSED_RGB_PVRTC_2BPPV1_IMG</code></li>
    <li><code>ext.COMPRESSED_RGBA_PVRTC_2BPPV1_IMG</code></li>
   </ul>
  </li>
  <li>When using the {{domxref("WEBGL_compressed_texture_atc")}} extension:
   <ul>
    <li><code>ext.COMPRESSED_RGB_ATC_WEBGL</code></li>
    <li><code>ext.COMPRESSED_RGBA_ATC_EXPLICIT_ALPHA_WEBGL</code></li>
    <li><code>ext.COMPRESSED_RGBA_ATC_INTERPOLATED_ALPHA_WEBGL</code></li>
   </ul>
  </li>
  <li>When using the {{domxref("WEBGL_compressed_texture_astc")}} extension:
   <ul>
    <li><code>ext.COMPRESSED_RGBA_ASTC_4x4_KHR<br>
     ext.COMPRESSED_SRGB8_ALPHA8_ASTC_4x4_KHR</code></li>
    <li><code>ext.COMPRESSED_RGBA_ASTC_5x4_KHR<br>
     ext.COMPRESSED_SRGB8_ALPHA8_ASTC_5x4_KHR</code></li>
    <li><code>ext.COMPRESSED_RGBA_ASTC_5x5_KHR<br>
     ext.COMPRESSED_SRGB8_ALPHA8_ASTC_5x5_KHR</code></li>
    <li><code>ext.COMPRESSED_RGBA_ASTC_6x5_KHR<br>
     ext.COMPRESSED_SRGB8_ALPHA8_ASTC_6x5_KHR</code></li>
    <li><code>ext.COMPRESSED_RGBA_ASTC_6x6_KHR<br>
     ext.COMPRESSED_SRGB8_ALPHA8_ASTC_6x6_KHR</code></li>
    <li><code>ext.COMPRESSED_RGBA_ASTC_8x5_KHR<br>
     ext.COMPRESSED_SRGB8_ALPHA8_ASTC_8x5_KHR</code></li>
    <li><code>ext.COMPRESSED_RGBA_ASTC_8x6_KHR<br>
     ext.COMPRESSED_SRGB8_ALPHA8_ASTC_8x6_KHR</code></li>
    <li><code>ext.COMPRESSED_RGBA_ASTC_8x8_KHR<br>
     ext.COMPRESSED_SRGB8_ALPHA8_ASTC_8x8_KHR</code></li>
    <li><code>ext.COMPRESSED_RGBA_ASTC_10x5_KHR<br>
     ext.COMPRESSED_SRGB8_ALPHA8_ASTC_10x5_KHR</code></li>
    <li><code>ext.COMPRESSED_RGBA_ASTC_10x6_KHR<br>
     ext.COMPRESSED_SRGB8_ALPHA8_ASTC_10x6_KHR</code></li>
    <li><code>ext.COMPRESSED_RGBA_ASTC_10x6_KHR<br>
     ext.COMPRESSED_SRGB8_ALPHA8_ASTC_10x6_KHR</code></li>
    <li><code>ext.COMPRESSED_RGBA_ASTC_10x10_KHR<br>
     ext.COMPRESSED_SRGB8_ALPHA8_ASTC_10x10_KHR</code></li>
    <li><code>ext.COMPRESSED_RGBA_ASTC_12x10_KHR<br>
     ext.COMPRESSED_SRGB8_ALPHA8_ASTC_12x10_KHR</code></li>
    <li><code>ext.COMPRESSED_RGBA_ASTC_12x12_KHR<br>
     ext.COMPRESSED_SRGB8_ALPHA8_ASTC_12x12_KHR</code></li>
   </ul>
  </li>
  <li>When using the {{domxref("EXT_texture_compression_bptc")}} extension:
   <ul>
    <li><code>ext.COMPRESSED_RGBA_BPTC_UNORM_EXT</code></li>
    <li><code>ext.COMPRESSED_SRGB_ALPHA_BPTC_UNORM_EXT</code></li>
    <li><code>ext.COMPRESSED_RGB_BPTC_SIGNED_FLOAT_EXT</code></li>
    <li><code>ext.COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT_EXT</code></li>
   </ul>
  </li>
  <li>When using the {{domxref("EXT_texture_compression_rgtc")}} extension:
   <ul>
    <li><code>ext.COMPRESSED_RED_RGTC1_EXT</code></li>
    <li><code>ext.COMPRESSED_SIGNED_RED_RGTC1_EXT</code></li>
    <li><code>ext.COMPRESSED_RED_GREEN_RGTC2_EXT</code></li>
    <li><code>ext.COMPRESSED_SIGNED_RED_GREEN_RGTC2_EXT</code></li>
   </ul>
  </li>
 </ul>
 </dd>
 <dt><code>imageSize</code></dt>
 <dd>A {{domxref("GLsizei")}} specifying the number of bytes to read from the buffer bound to <code>gl.PIXEL_UNPACK_BUFFER</code>.</dd>
 <dt><code>offset</code></dt>
 <dd>A {{domxref("GLintptr")}} specifying the offset in bytes from which to read from the buffer bound to <code>gl.PIXEL_UNPACK_BUFFER</code>.</dd>
 <dt><code>pixels</code></dt>
 <dd>An {{domxref("ArrayBufferView")}} that be used as a data store for the compressed image data in memory.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var ext = (
  gl.getExtension('WEBGL_compressed_texture_s3tc') ||
  gl.getExtension('MOZ_WEBGL_compressed_texture_s3tc') ||
  gl.getExtension('WEBKIT_WEBGL_compressed_texture_s3tc')
);
gl.compressedTexSubImage2D(gl.TEXTURE_2D, 0, 256, 256, 512, 512, ext.COMPRESSED_RGBA_S3TC_DXT5_EXT, textureData);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#COMPRESSEDTEXSUBIMAGE2D", "compressedTexSubImage2D")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glCompressedTexSubImage2D.xml", "glCompressedTexSubImage2D")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the (similar) OpenGL ES 2.0 API.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glCompressedTexSubImage2D.xhtml", "glCompressedTexSubImage2D")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL ES 3.0 API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.compressedTexSubImage2D")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebGL_API/Using_Extensions">Using WebGL extensions</a></li>
 <li>{{domxref("WebGLRenderingContext.getExtension()")}}</li>
 <li>{{domxref("WebGLRenderingContext.compressedTexImage2D()")}}</li>
 <li>{{domxref("WEBGL_compressed_texture_s3tc")}}</li>
 <li>{{domxref("WEBGL_compressed_texture_s3tc_srgb")}}</li>
 <li>{{domxref("WEBGL_compressed_texture_etc")}}</li>
 <li>{{domxref("WEBGL_compressed_texture_pvrtc")}}</li>
 <li>{{domxref("WEBGL_compressed_texture_atc")}}</li>
 <li>{{domxref("WEBGL_compressed_texture_astc")}}</li>
 <li>{{domxref("EXT_texture_compression_bptc")}}</li>
 <li>{{domxref("EXT_texture_compression_rgtc")}}</li>
</ul>
